package com.zj365.dc.activity

import android.content.Intent
import android.view.LayoutInflater
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import androidx.recyclerview.widget.LinearLayoutManager
import com.alibaba.android.arouter.facade.annotation.Route
import com.google.android.material.bottomsheet.BottomSheetDialog
import com.luck.picture.lib.PictureSelector
import com.luck.picture.lib.config.PictureConfig
import com.luck.picture.lib.config.PictureMimeType
import com.xty.base.act.BaseVmAct
import com.xty.base.vm.BaseVm
import com.xty.common.arouter.ARouterUrl
import com.xty.common.arouter.RouteManager
import com.xty.common.picture.PictureUtils
import com.xty.common.util.SpannableUtils
import com.xty.network.model.FoodRecoginzeInfo
import com.zj365.dc.BuildConfig
import com.zj365.dc.adapter.RecognizeResultAdapter
import com.zj365.dc.databinding.ActRecognizeResultBinding
import com.zj365.dc.vm.DietManagementVm
import com.zj365.health.R

@Route(path = ARouterUrl.RECOGNIZE_RESULT)
class RecognizeResultAct : BaseVmAct<DietManagementVm>() {

    val binding by lazy{ ActRecognizeResultBinding.inflate(layoutInflater)}

    val adapter by lazy { RecognizeResultAdapter() }

    var bottomSheetDialog: BottomSheetDialog? = null

    var type:String? = null
    var fileUrl :String? = null

    var currentId:String?= null

    var foodRecoginzeInfo: FoodRecoginzeInfo? = null
    override fun liveObserver() {
        mViewModel.foodRecoginzeInfoLiveData.observe(this){
            adapter.setNewInstance(it.data)
        }
    }

    override fun initView() {
        super.initView()
        statusBar(binding.title.mView)
        binding.title.mTvTitle.text = "识别结果"

        type = intent.getStringExtra("type")
        fileUrl = intent.getStringExtra("fileUrl")

        fileUrl?.let {
            mViewModel.submit(type!!,it)
        }

        binding.title.mIvBack.setOnClickListener {
            finish()
        }
        initAdapter()
        binding.tvPhotographAgain.setOnClickListener {

        }
        binding.tvDetail.setOnClickListener {
            currentId?.let {
                bundle.clear()
                bundle.putString("web_site_url","${BuildConfig.h5url}pages/index/index?pageId=mealsDetail&id=${it}")
                RouteManager.goAct(ARouterUrl.H5_ACT,bundle)
            }


        }

        initBottomDialog()

    }

    fun initAdapter(){
        binding.recycler.layoutManager = LinearLayoutManager(this,LinearLayoutManager.HORIZONTAL,false)
        binding.recycler.adapter = adapter
        adapter.setOnItemChildClickListener { adapter, view, position ->
            foodRecoginzeInfo = adapter.getItem(position) as FoodRecoginzeInfo

            foodRecoginzeInfo?.let {
                currentId = it.name
                binding.tvAnalyzeTitle.text = it.name
                val list = mutableListOf<com.xty.common.model.ReportBean>()
            }
        }
    }

    override fun initData() {
        super.initData()
    }

    override fun setLayout() = binding.root

    fun initBottomDialog() {
        if (bottomSheetDialog == null) {
            bottomSheetDialog = BottomSheetDialog(this, R.style.Theme_ChartDialogManager)
            bottomSheetDialog?.let { dialog ->
                val view = LayoutInflater.from(this).inflate(R.layout.dialog_choose_pic, null)
                dialog.setContentView(view)

                val tvTakePhoto = view.findViewById<TextView>(R.id.tv_take_photo)
                val tvChoosePhotoAlbum = view.findViewById<TextView>(R.id.tv_choose_photo_album)
                val tvCancel = view.findViewById<TextView>(R.id.tv_cancel)
                tvCancel.setOnClickListener {
                    dialog.dismiss()
                }

                tvTakePhoto.setOnClickListener {
                    PictureUtils.openTheCamera(this, PictureMimeType.ofImage())
                    dialog.dismiss()
                }

                tvChoosePhotoAlbum.setOnClickListener {
                    PictureUtils.openCamera(this, PictureMimeType.ofImage(),9)
                    dialog.dismiss()

                }

            }
        }

    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)

        if (resultCode === RESULT_OK) {
            when (requestCode) {
                PictureConfig.CHOOSE_REQUEST -> {
                    var result = PictureSelector.obtainMultipleResult(data)
                    if (result.size > 0) {
                        if (result.isNotEmpty()) {
                            fileUrl = result[0].compressPath

                            fileUrl?.let {
                               mViewModel.submit(type!!,it)
                            }

                        }
                    }
                }

            }
        }
    }
}