package com.zj365.dc.fragment

import android.content.Intent
import android.graphics.Color
import android.view.View
import androidx.localbroadcastmanager.content.LocalBroadcastManager
import androidx.recyclerview.widget.LinearLayoutManager
import com.tencent.qcloud.tuicore.TUIConstants
import com.xty.base.fragment.BaseFragList
import com.xty.common.arouter.ARouterUrl
import com.xty.common.arouter.RouteManager
import com.xty.common.event.LoginOrRegisterEvent
import com.xty.common.event.LoginOutEvent
import com.xty.common.event.MessageReadEvent
import com.xty.network.model.SystemMsgBean
import com.zj365.dc.adapter.HomeMessageAdapter
import com.zj365.dc.databinding.FragMessageBinding
import com.zj365.dc.vm.MessageVm
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode

class MessageFragment : BaseFragList<MessageVm>()  {

    val binding by lazy { FragMessageBinding.inflate(layoutInflater) }

    val adapter by lazy { HomeMessageAdapter() }

    var msgList = ArrayList<SystemMsgBean>()
    override fun initAdapter() {
        binding.mRecycle.layoutManager= LinearLayoutManager(requireContext())
        binding.mRecycle.adapter=adapter
        adapter.setOnItemClickListener { adapter, view, position ->
            var bean = adapter.getItem(position) as SystemMsgBean
            bundle.clear()
            bundle.putInt("msgType",bean.type)
            RouteManager.goAct(ARouterUrl.MESSAGE_TYPE,bundle)
        }
    }

    override fun initData() {
        super.initData()

    }

    override fun initView() {
        super.initView()
        statusBar(binding.title.mView)
        binding.title.mTvTitle.text="消息"
        binding.title.mTvRight.text="全部已读"
        binding.title.mTvRight.setTextColor(Color.parseColor("#02C191"))
        binding.title.mTvRight.visibility = View.VISIBLE
        binding.title.mIvBack.visibility = View.INVISIBLE
        binding.title.mTvRight.setOnClickListener {
            mViewModel.setAllRead()
        }
        initAdapter()
        setRecycleRefresh(binding.mRecycle,binding.mRefresh)
    }

    override fun refresh() {
       mViewModel.getSystemMsg()
    }

    override fun setViewModel()= MessageVm()

    override fun observer() {
        mViewModel.msgData.observe(this){
            adapter.setNewInstance(it.data.list)
            val intent = Intent()
            intent.action = TUIConstants.CONVERSATION_UNREAD_COUNT_ACTION
            intent.putExtra(TUIConstants.UNREAD_COUNT_EXTRA, it.data.unReadCount)
            LocalBroadcastManager.getInstance(requireContext())
                .sendBroadcast(intent)
        }
        mViewModel.msgAllRead.observe(this){
            refresh()
        }

    }

    override fun setLayout()=binding.root

    @Subscribe(threadMode = ThreadMode.MAIN)
    fun LoginOrRegisterChange(event: LoginOrRegisterEvent){
        refresh()
    }

    @Subscribe(threadMode = ThreadMode.MAIN)
    fun loginOutChange(event: LoginOutEvent){

    }

    @Subscribe(threadMode = ThreadMode.MAIN)
    fun readMsg(event:MessageReadEvent){
        refresh()
    }

}