package com.xty.base.h5

import android.content.Context
import android.webkit.JavascriptInterface
import com.xty.base.act.BaseVmAct
import com.xty.base.act.IBaseAct
import com.xty.common.Const
import com.xty.common.LogUtils
import com.xty.common.MMkvHelper
import com.xty.common.util.ToastUtils
import org.json.JSONObject

open class CloudJSBridge(val context: Context, val listener: IJsBridge) {
    private var baseActivity: BaseVmAct<*> = context as BaseVmAct<*>
    @JavascriptInterface
    fun getBaseInfoData(str: String?) {
      LogUtils.e("CloudJSBridge","getBaseInfoData str")
        str?.apply {
            val userId = if (MMkvHelper.getLong(Const.USER_ID).toString() == "0") {
                ""
            } else { LogUtils.e("CloudJSBridge","str")
                MMkvHelper.getLong(Const.USER_ID).toString()
            }

            val jsonObject = JSONObject()
            jsonObject.put("statuHeight", WebUtils.getStatesBar())
            jsonObject.put("token", MMkvHelper.getString(Const.Auth_Token))

            jsonObject.put("userId", userId)
            listener.sendDataToJS("sendBaseInfo", jsonObject.toString())
        }
    }

    @JavascriptInterface
    fun getIsFromApp(str:String?){
        LogUtils.e("CloudJSBridge","getIsFromApp str")
        str?.let {
            val jsonObject = JSONObject()
            jsonObject.put("isAPP", 1)
            listener.sendDataToJS("sendIsFrom ", jsonObject.toString())
        }
    }

    @JavascriptInterface
    fun onBack(str: String?){
        LogUtils.e("CloudJSBridge","onBack str")
        baseActivity.finish()
    }
    @JavascriptInterface
    fun gotoElectronicFence(str: String?){
        LogUtils.e("CloudJSBridge","gotoElectronicFence str")
        ToastUtils(context).showToast("敬请期待")

    }

}